package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaEmailTypeDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaEmailType;
import com.loafle.overflow.service.central.meta.MetaEmailTypeService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 7. 27.
 */
@Service("MetaEmailTypeService")
public class CentralMetaEmailTypeService implements MetaEmailTypeService {

  @Autowired
  private MetaEmailTypeDAO metaEmailTypeDAO;

  @Override
  public MetaEmailType regist(MetaEmailType metaCryptoType) throws OverflowException {
    return this.metaEmailTypeDAO.save(metaCryptoType);
  }

  @Override
  public MetaEmailType readByKey(String key) throws OverflowException {
    return this.metaEmailTypeDAO.findByKey(key);
  }

  @Override
  public List<MetaEmailType> readAll() throws OverflowException {
    return this.metaEmailTypeDAO.findAll();
  }
}
