package com.loafle.overflow.central.spring;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.cache.CacheManager;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.cache.caffeine.CaffeineCacheManager;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@EnableCaching
@Configuration
public class CacheConfiguration {
  @Value("#{'${cache.cache-names}'.split(',')}")
  private String[] cacheNames;
  @Value("${cache.caffeine.spec}")
  private String spec;

  @Bean
  public CacheManager cacheManager() {
    // A EhCache based Cache manager
    CaffeineCacheManager cacheManager = new CaffeineCacheManager(cacheNames);
    cacheManager.setAllowNullValues(false);
    cacheManager.setCacheSpecification(spec);
    return cacheManager;
  }
}
